# Plots the log-likelihood for three runs, with burnin as last parameter...

args <- commandArgs();
numFiles <- length(args) - 5;
print(c("Numfiles is ", numFiles));

theColors <- rainbow(n=10);
#rgb(0,0,0); 
#colors();

burnin <- as.numeric(args[5]);

data <-  vector(mode="list", length=numFiles);

for (i in 1:numFiles) {
	theData <- read.table(args[(5+i)], sep='\t', header=T);
	data[[i]] <- data.frame(theData);
}


maxY <- -9999999999999;
maxX <- 0;
minY <- 9999999999;

for (i in 1:numFiles) {
	maxY <- max(maxY, data[[i]]$LnLikelihood[data[[i]]$Count > burnin]);
	minY <- min(minY, data[[i]]$LnLikelihood[data[[i]]$Count > burnin]);
	maxX <- max(maxX, data[[i]]$Count);
}	

for (i in 1:numFiles) {
	fname <- paste("./histPlot_", i, ".pdf", sep="");
	pdf(file=fname, bg="transparent", version="1.4");
	#hist( data[[i]]$LnLikelihood[data[[i]]$Count > burnin], col=theColors[i], xlab="log(Likelihood)", main="");
	hist( data[[i]]$LnLikelihood[data[[i]]$Count > burnin], col='black', xlab="log(Likelihood)", main="");
#	theMean <- mean(data[[i]]$LnLikelihood[data[[i]]$Count > burnin]);
#	abline(h=theMean, col=theColors[i], lwd=2);
	dev.off();
}
