#!/usr/bin/perl

# Plots a heatmap of the posterior mean and variance over a rate matrix output from PLEX

$burnin = shift;
$file = shift;

open(IN, $file) or die "Can't open $file\n";
$numMixture = 1;
$numStates = 20;

$whichCount = 0;
$matCount = 0;

$numSkip = 0;
while ($line = <IN>) {
	chomp($line);
	if ($line =~ /Model\s+[0-9]+\s+[0-9]+/) {
               if ($matCount > ($burnin * $numMixture)) { 
			chomp($line);
			@tok2 = split('\s+', $line); 
			print $tok2[2] . "\t" . $tok2[3] . "\n";
		} 
	}

	if ($line =~ /Model\s+[0-9]+$/) {
		$line = <IN>;
		#print "Start of matrix found...\n";
	
		if ($numSkip > 0) { $numSkip--; next; }

		$whichCount++;
		if (($whichCount > ($numMixture-1))) { $whichCount = 0; $numSkip = $numMixture; } else {  }
		$matCount++;
		
		if ($matCount <= ($burnin * $numMixture)) {  next; }

		$numRows = 0;
		while (($line = <IN>) && ($numRows < $numStates)) {
			@tok = split(/\s+/, $line);
			#print "	Row $numRows: ";
			for ($i=1; $i<($numStates+1); $i++) {	
					#print "$tok[$i]\t";
				$theMats[($whichCount)][$numRows][($i-1)] += $tok[$i];
			#	print "$theMats[$lineCount][$i]\t";
			} #print "\n";

			$numRows++;
		}
	}
}
close IN;

$numProcessed = (($matCount - ($burnin * $numMixture)) / $numMixture);
print "Processed " . (($matCount - ($burnin * $numMixture)) / $numMixture) . " matrices!\n";
print "\n\n";

for ($i=0; $i<$numMixture;$i++) {
	$outF = ">posteriorMean_" . ($i+1) . ".mat";
	open(OUT, $outF);
	for ($j=0;$j<$numStates;$j++) {
		for ($k=0;$k<$numStates;$k++) {
			print OUT "" . ($theMats[$i][$j][$k]/$numProcessed);
			if ($k<($numStates-1)) { print OUT "\t"; }
		} print OUT "\n";
	}
	print OUT "\n\n";
	close OUT;

	# Plot sorted heatmap...


}	

print "Doing variance heatmap...\n";
$postBurnin = (($matCount - ($burnin * $numMixture)) / $numMixture) ;
$cmd = "$file $burnin $postBurnin";

system("perl posteriorVariance.pl $cmd");

print "Calling plotHeatmaps.pl...\n";
# Plot unsorted heatmap...
$allFiles = "";
for ($i=0; $i<$numMixture;$i++) {
	$allFiles = $allFiles . " posteriorMean_" . ($i+1) . ".mat";	
}
system("perl plotHeatmaps.pl $allFiles");
	
