#!/usr/bin/perl

#@files = glob("ATPaseF0_6_5catRAR_matrixoutfile_1");
#$numChains = $#files + 1;

$numChains = 1;
$file = shift;
$burnin = shift;
$minSize = shift;
$n = 20;

@matrix = ();

#print "There are $numChains chains.  Doing length = $minSize\n";
$fileCount = 0;
	print "Processing file $file...\n";
	open (IN, $file) or die "Can't open file $file\n";

	$count = -1;
	while ( ($line = <IN>) && ($count < ($minSize + $burnin)) ) {
		if ($line =~ /Model/) {
			$count++;
			if ($count >= $burnin) {
			#print "	DOING MATRIX $count (after " . ($burnin / 2) ." samples of burnin)...\n";
			$line = <IN>;

			for ($i=0; $i<$n;$i++) {
				$line = <IN>;
				chomp($line);
				@tok = split(/\s+/, $line);
				#print "Got $#tok tokens from line: $line\n";
				for ($j=0; $j<$n; $j++) {
				#	print $tok[$j+2] . "\t";
					if ($j == $i) {
						$matrix[$fileCount][($count - $burnin)][($i*$n)+$j] = $tok[$j+1];
					} else {
						$matrix[$fileCount][($count - $burnin)][($i*$n)+$j] = ($tok[$j+1]);
					}
				}
				#print "\n";
			}

			#print "	End of full matrix.\n";
			#exit(-1);
			}
		}
	}

	$fileCount++;
	close IN;

# Now do the processing...
@psiDotJ = ();
@psiDot = ();

$numParms = $n * $n;

@B = ();
@sSq = ();
@W = ();
@PSRF = ();

for ($k=0; $k<$numParms;$k++) {
#print "Parm $k...\n";
for ($j=0; $j<$numChains;$j++) {
	$psiDotJ[$k][$j] = 0.0;
	for ($i=0; $i<$minSize; $i++) {
		$psiDotJ[$k][$j] += $matrix[$j][$i][$k];
	}	
	$psiDotJ[$k][$j] /= $minSize;
#	print "	psi-dot-J for $k, $j	$psiDotJ[$k][$j]\n";
} #j

# Now do within chain variance: W
for ($j=0; $j<=$numChains; $j++) {
	$sSq[$k][$j] = 0.0;
	for ($i=0; $i<$minSize; $i++) {
		$sSq[$k][$j] += ( ( $matrix[$j][$i][$k] - $psiDotJ[$k][$j] ) * ( $matrix[$j][$i][$k] - $psiDotJ[$k][$j] ) );
	}
	$sSq[$k][$j] /= ($minSize - 1);
}

#print "Parameter $k	PSRF	";
#$rounded = sprintf("%.4f", $PSRF[$k]);
#$rounded_W = sprintf("%.4f", $W[$k]);
#$rounded_B = sprintf("%.4f", $B[$k]);
#print "$rounded\tW\t$rounded_W\tB\t$rounded_B\n";
}

 #k
$outF = ">posteriorVar_1.mat";
open(OUT, $outF) or die "Can't open outfile\n";
for ($i=0; $i<$n; $i++) {
	for ($j=0; $j<$n; $j++) {
		if ( $psiDotJ[($i*$n)+$j][0] == 0.0 )  {
		#	print "ERROR: apparent posterior mean for " . ($i*$n)+$j . " is " . $psiDotJ[($i*$n)+$j][0] . "\n";
	#		$temp = 0.00001;
			$rounded = sprintf("%.6f", (($sSq[($i*$n)+$j][0]))); 
			# $rounded = sprintf("%.6f", (sqrt($sSq[($i*$n)+$j][0])/$temp));
		} else {
		#	print "ERROR: apparent posterior mean for " . ($i*$n)+$j . " is $psiDotJ[($i*$n)+$j][0] \n";
		#		$rounded = sprintf("%.6f", (sqrt($sSq[($i*$n)+$j][0])/$psiDotJ[($i*$n)+$j][0] ));
			$rounded = sprintf("%.6f", (($sSq[($i*$n)+$j][0]))); 
		}
		print OUT $rounded;
		if ($j < ($n-1)) { print OUT "\t"; }
		else { print OUT "\n"; }
	} 
}
close OUT;
