/*
 *  Matrix3DLite.h
 *  PLEX
 *
 *  Created by A.P. Jason de Koning on 9/21/07.
 *
 */

template <typename DataType>
class Matrix3DLite {
	public:
			
		int	fRows;
		int	fCols;
		int	fLayers;

			
		Matrix3DLite(void);
		int empty();
		
		Matrix3DLite(
			int			inRows,
			int			inColumns,
			int			inLayers,
			const DataType&		inValue = DataType());
		Matrix3DLite(
			const Matrix3DLite&		inMatrix);
virtual	~Matrix3DLite(void) {}

			
virtual	void							fill(
			const DataType&		inVal);

virtual	void							resize(
			int			inRows,
			int			inColumns,
			int			inLayers,
			const DataType&		inVal = DataType());
			
	private:
	DataType								*mRows;
};


//---------------------------------------------------------------------------
template <typename DataType>
Matrix3DLite<DataType>::Matrix3DLite(void)
{
}

//---------------------------------------------------------------------------
template <typename DataType>
Matrix3DLite<DataType>::Matrix3DLite(
	int		inRows,
	int		inColumns,
	int		inLayers,
	const DataType&	inValue)
{
	resize(inRows, inColumns, inLayers, inValue);
}

//---------------------------------------------------------------------------
template <typename DataType>
Matrix3DLite<DataType>::Matrix3DLite(
	const Matrix3DLite&	inMatrix)
{
}


//---------------------------------------------------------------------------
template <typename DataType>
void
Matrix3DLite<DataType>::fill(
	const DataType&	inVal)
{
	for (int i = 0; i < (fRows * fCols * fLayers); i++)
		mRows[i] = inVal;
}

//---------------------------------------------------------------------------
template <typename DataType>
int
Matrix3DLite<DataType>::empty(
	void)
{
	if ((fRows * fCols * fLayers) == 0) { return 1; } else { return 0; }
}
//---------------------------------------------------------------------------
template <typename DataType>
void
Matrix3DLite<DataType>::resize(
	int		inRows,
	int		inColumns,
	int		inLayers,
	const DataType&	inVal)
{
	delete [] mRows;
	mRows = new DataType[ (inLayers * inRows * inColumns) ];
	fRows= inRows; fCols = inColumns; fLayers = inLayers;
}

