/*
 *  NodeDistanceMaker.h
 *  CLAMP
 *
 *  Created by Chip Jarred.
 *  Copyright (c) 2004 Dr. David Pollock. All rights reserved.
 *
 */

#ifndef NodeDistanceMaker_h__
#define NodeDistanceMaker_h__

#include "TreeParser.h"
#include "TreeNodeData.h"


#include <string>

class NodeDistanceMaker : public TreeParser::NodeMaker
{
	public:
		static	const std::string		cInitName;
		
		typedef	TreeNode	node_type;
		virtual							~NodeDistanceMaker(void);
		virtual	node_type*				Make(
											const std::string&	inNodeDescription,
											node_type*			inNodeToSetFromDescription = 0) const;
	private:
				double					GetInitDistance() const;
				const std::string&		GetInitName() const;
				
		static	unsigned int			sNumNodes;
};

#endif // NodeDistanceMaker_h__
