/*
 *  Options.cpp
 *  PLEX
 *
 *  A.P. Jason de Koning, jason.de.koning@gmail.com
 *  http://jasondk.org
 *
 *  David Pollock lab, University of Colorado School of Medicine
 *  http://www.evolutionarygenomics.com
 *  All rights reserved.

 */

#include "Options.h"
#include "macrodefine.h"

Options::Options() {
	
	numThreads = 1;
	
	__ASRVmode = 0;
	__globalLikelihoodTemp = 1.0;
	
	numGenerations = 1;
	
	randseed = 12345;
	
	capUniformizationRate = 0;
	capNumTreeNodes = false;
	
	scaleByFrequencies = 1;
	outputSiteRates = 0;
	
	coevol = 0;
	coevol_doPosteriorPredictiveNull = 0;
	coevol_minNumSubstitutions = 1;

	updatebls = 0;
	brlenupdatefreq = 0.01;
	
	allowASRV = 0;
	gammaShapeASRV = 0.19414;
	updateASRVparms = 0;
	
	numCatASRV = 1;
	scaleRateMatrix = 0;
	
	suppressFileOutput = 0;
	outputFrequency = 25;
	
	datatype = 1;
	outputIncompleteLogL = 0;
	doB1uStar = 0;
	
	reversibleModel = 0;
	numDiscreteBLs = 1;
	discreteBLs.push_back(0.005);
	HwangGreen = 0;
	
	maxBL = 0.08;

	ancStateUpdateFreq = 0.998;
	forceFullMarginalUpdate = 0;
	
	countExpectedSubstitutions = 0;
	
	doRAR = 0;
	numCat = 5;
	fixedRates = -1;
	freeFreqs = 0;
	
	DRA = 0;
	DRAprior = 0.001;
    
    // LEGACY STUFF
    m_strTreefile = (char*) malloc(sizeof(char) * MAXNAME);
    m_strSeqfile = (char*) malloc(sizeof(char) * MAXNAME);
    m_strPositionfile = (char*) malloc(sizeof(char) * MAXNAME);
    m_strLengthfile = (char*) malloc(sizeof(char) * MAXNAME);
    m_strOLfile = (char*) malloc(sizeof(char) * MAXNAME);
    m_strTreeOutfile = (char*) malloc(sizeof(char) * MAXNAME);
    m_strSeqOutfile = (char*) malloc(sizeof(char) * MAXNAME);
    m_strCountOutfile = (char*) malloc(sizeof(char) * MAXNAME);
    m_strLikelihoodOutfile = (char*) malloc(sizeof(char) * MAXNAME);
    m_strMatrixOutfile = (char*) malloc(sizeof(char) * MAXNAME);

}