/*
 *  RandomGenerator.h
 *  PLEX
 *
 *  Created by Chip Jarred.
 *  Copyright (c) 2004 Dr. David Pollock. All rights reserved.
 *
 */

/*
 *
 *  random generator
 *
 */


#ifndef RandomGenerator_h__
#define RandomGenerator_h__

#include <memory>

class RandomGenerator
{
	public:
											RandomGenerator(
												void);
		
				double							Random(
												void);
												
				void							SetSeed(
												int inSeed);
				
		static	RandomGenerator&						GetGlobalGenerator(
												void);
		
	protected:
	private:
	
				unsigned int						mW;
				unsigned int						mX;
				unsigned int						mY;
				unsigned int						mZ;
				
		static	const unsigned int						cWDefault	= 13757;
		static	const unsigned int						cXDefault	= 11;
		static	const unsigned int						cYDefault	= 23;
		static	const unsigned int						cZDefault	= 137;
		
		static	const bool							cFastRandomNumber = false; // true?
};

#endif // RandomGenerator_h__
