/*
 *  Sequence.h
 *  CLAMP
 *
 *  Created by Chip Jarred.
 *  Copyright (c) 2004 Dr. David Pollock. All rights reserved.
 *
 */

// OBSOLETE CLASS. STILL USED IN SOME OLD CODE; WILL BE FULLY PHASED OUT SOON.

#ifndef Sequence_h__
#define Sequence_h__

#include <string>

#include "macrodefine.h"

class Sequence_Impl;

class Sequence
{
	public:
		static const char					cEndSeq = ENDSEQ;
		static const char					cNewSeq = NEWSEQ;
		
		typedef unsigned int					size_type;
		
		// -----------------------------------------------------------------------------------------------
		// class SharedTransaction
		//
		// Use this class in order to alter all copies of a Sequence that share the same underlying data
		// simultaneously.
		class SharedTransaction
		{
			public:
							SharedTransaction(
								Sequence&	inSequence)
							:	mSequence(inSequence)
							{
								mSequence.BeginSharedChange();
							}
							
							~SharedTransaction(void)
							{
								mSequence.EndSharedChange();
							}
			private:
				Sequence&	mSequence;
		};
		// -----------------------------------------------------------------------------------------------
		
												Sequence(void);
												Sequence(
													const Sequence&		inSrc);
				explicit						Sequence(
													const std::string&	inSrc);
		virtual									~Sequence(void);
		
				const Sequence&					operator=(
													const Sequence&		inSrc);
				bool							operator==(
													const Sequence&		inSrc) const;
				bool							operator!=(
													const Sequence&		inSrc) const
												{
													return !operator==(inSrc);
												}
													
				const char						operator[](
													size_type			inIndex) const;
													
				void							resize(
													size_type			inNewSize);
				size_type						size(void) const;
				
												// This method gets the sequence len which is not necessarily the
												// the same as size().
				size_type						GetLen(void) const;
				
				void							clear();

				bool							empty() const;
				
				void							SetAtIndex(
													size_type			inIndex,
													char				inValue);

				void							push_back(
													char				inVal);

				std::string						str(void) const;
				
				void							SetString(const std::string& inString);
				
	//			void							Mix(
	//												std::vector<int>	inSeq1,
	//												std::vector< std::vector<int> >*	inSeq2);
													
				int							GetAssignment(void);
				
				void							SetAssignment(const int& inAssignment);
	
				Sequence_Impl*					mImpl;
				
	protected:
	private:
		friend	class SharedTransaction;
		
				void							Swap(
													Sequence&			ioSwapee);
				void							PrepareToModify(void);
				
												// These two methods are used to bracket when you want to disable
												// the copy-on-write semantics of this object so that all copies
												// will be changed.
				void							BeginSharedChange(void);
				void							EndSharedChange(void);
};
#endif // Sequence_h__
