/*
 *  SequenceAddressing.h
 *  PLEX
 *
 *  Created by A.P. Jason de Koning on 9/25/08.
 *  Copyright 2008 __MyCompanyName__. All rights reserved.
 *
 */

class Sequence;
class Sequence_Impl
{
	public:
		typedef unsigned int						RefCount;
		typedef unsigned int						size_type;
		
													Sequence_Impl(
														const std::string&			inSeqenceStr = "");
													Sequence_Impl(
														const Sequence_Impl&	inSrc);
													~Sequence_Impl(void);
													
				bool								IsShared(void) const;
				void								Retain(void) const;
				void								Release(void) const;
				
				void								resize(
														size_type				inNewSize);
				size_type							size(void) const;
				
				size_type							GetLen(void) const;
				
				void								SetAtIndex(
														size_type				inIndex,
														char					inVal);
				void								push_back(
														char					inVal);
														
	//			const std::string&						str(void) const;
				
				std::string							str(void) const;
				
				void								SetString(const std::string& inString);
				
				int								GetAssignment(void);
				
				void								SetAssignment(const int& inAssignment);
				
				void								Mix(
														Sequence*	inSeq);
				
				const char							operator[](
														size_type				inIndex) const;
				bool								operator==(
														const Sequence_Impl&	inSrc) const;
														
				void								BeginSharedChange(void);
				void								EndSharedChange(void);
				std::string							mSequenceStr;
	protected:
	private:
				mutable	RefCount						mRefCount;
				RefCount							mSharedChangeCount;
				int								mModelAssignment;
};

