/*
 *  TreeNodeData.cpp
 *  Created by Chip Jarred.
 *
 *  Revised by A.P. Jason de Koning, jason.de.koning@gmail.com
 *  http://jasondk.org
 *
 *  David Pollock lab, University of Colorado School of Medicine
 *  http://www.evolutionarygenomics.com
 *  All rights reserved.
 */

#include "TreeNodeData.h"

#include <algorithm>

using std::fill_n;


//---------------------------------------------------------------------------
TreeNodeData_::TreeNodeData_() {
	
    distance = cInitDistance;
    id =0;
    //		tips(0),
    sequence.clear();
    //		state(0),
    //		color(0),
    //		thickness(0),
    //		probto(0),
    //		likeleft(0),
    //		likeright(0),
    //		likeup(0),
    //		likechange(0),
    //		likenochange(0),
    
    //countchange.fill(0);
    //);
    //countModelchange3D();

	fill_n(&name[0], MAXNAME, '\0');
	siteLallocatedFlag = 0;
	doScaling = 0;
	branchLengthIndex = 0;
}


//---------------------------------------------------------------------------
TreeNodeData_::TreeNodeData_(
                             const TreeNodeData_& inSrc)
{
	strcpy(name, inSrc.name);
	distance = inSrc.distance;
	id = inSrc.id;
	sequence = inSrc.sequence;
	countchange = inSrc.countchange;
	probmatrix3D = inSrc.probmatrix3D;
	countModelchange3D = inSrc.countModelchange3D;
	siteLallocatedFlag = 0;
	doScaling = inSrc.doScaling;
}

//---------------------------------------------------------------------------
const TreeNodeData_&	TreeNodeData_::operator=(
                                                 const TreeNodeData_& inSrc)
{
	strcpy(name, inSrc.name);
	distance = inSrc.distance;
	id = inSrc.id;
	sequence = inSrc.sequence;
	countchange = inSrc.countchange;
	probmatrix3D = inSrc.probmatrix3D;
	countModelchange3D = inSrc.countModelchange3D;
	siteLallocatedFlag = 0;
	doScaling = inSrc.doScaling;
}
