/*
 *  macrodefine.h
 *  PLEX
 *
 *  Created by Wanjun Gu.
 *  Copyright (c) 2004 Dr. David Pollock. All rights reserved.
 *
 */

/*
 * this file include all the global definition in PLEX
*/

#ifndef macrodefine_h__
#define macrodefine_h__

#define ENDSEQ '*'
#define NEWSEQ '>'
#define FNAMESIG '>'
#define PNAMESIG ';'
#define ELN 13
#define ELN2 '\n'
#define EOS '\0'
#define FASTA 0
#define PIR 1

#define MAXNAME 500		// maximum length of filename and sequence name
#define MAXLINE 150000		// maximum lenght of line in input file

// tree, align specific
#define MAXLENGTH 20000		// maximum length of sequence alignment
#define MAXSTATES 65		// maximum number of state in the model
#define MAXTAXA 100		// maximum number of taxa in the alignment

#define BLOCK 70		// number of characters in each line when print sequence 


extern const double cSmallDistance;
extern const double cInitDistance;
extern const char* CONTROLFILE;
extern const char* ENDWORD;
extern const char* cWhitespaceChars;

#endif // macrodefine_h__
